=== src/CMakeLists.txt ===
#-----------------------------------------------------------------------------#
# Collect libcvc4 source files

libcvc4_add_sources(
  api/cvc4cpp.cpp
  api/cvc4cpp.h
  api/cvc4cppkind.h
  context/backtrackable.h
  context/cddense_set.h
  context/cdhashmap.h
  context/cdhashmap_forward.h
  context/cdhashset.h
  context/cdhashset_forward.h
  context/cdinsert_hashmap.h
  context/cdinsert_hashmap_forward.h
  context/cdlist.h
  context/cdlist_forward.h
  context/cdmaybe.h
  context/cdo.h
  context/cdqueue.h
  context/cdtrail_queue.h
  context/context.cpp
  context/context.h
  context/context_mm.cpp
  context/context_mm.h
  decision/decision_attributes.h
  decision/decision_engine.cpp
  decision/decision_engine.h
  decision/decision_strategy.h
  decision/justification_heuristic.cpp
  decision/justification_heuristic.h
  lib/clock_gettime.c
  lib/clock_gettime.h
  lib/ffs.c
  lib/ffs.h
  lib/replacements.h
  lib/strtok_r.c
  lib/strtok_r.h
  preprocessing/assertion_pipeline.cpp
  preprocessing/assertion_pipeline.h
  preprocessing/passes/ackermann.cpp
  preprocessing/passes/ackermann.h
  preprocessing/passes/apply_substs.cpp
  preprocessing/passes/apply_substs.h
  preprocessing/passes/bool_to_bv.cpp
  preprocessing/passes/bool_to_bv.h
  preprocessing/passes/bv_abstraction.cpp
  preprocessing/passes/bv_abstraction.h
  preprocessing/passes/bv_eager_atoms.cpp
  preprocessing/passes/bv_eager_atoms.h
  preprocessing/passes/bv_gauss.cpp
  preprocessing/passes/bv_gauss.h
  preprocessing/passes/bv_intro_pow2.cpp
  preprocessing/passes/bv_intro_pow2.h
  preprocessing/passes/bv_to_bool.cpp
  preprocessing/passes/bv_to_bool.h
  preprocessing/passes/bv_to_int.cpp
  preprocessing/passes/bv_to_int.h
  preprocessing/passes/extended_rewriter_pass.cpp
  preprocessing/passes/extended_rewriter_pass.h
  preprocessing/passes/global_negate.cpp
  preprocessing/passes/global_negate.h
  preprocessing/passes/ho_elim.cpp
  preprocessing/passes/ho_elim.h
  preprocessing/passes/int_to_bv.cpp
  preprocessing/passes/int_to_bv.h
  preprocessing/passes/ite_removal.cpp
  preprocessing/passes/ite_removal.h
  preprocessing/passes/ite_simp.cpp
  preprocessing/passes/ite_simp.h
  preprocessing/passes/miplib_trick.cpp
  preprocessing/passes/miplib_trick.h
  preprocessing/passes/nl_ext_purify.cpp
  preprocessing/passes/nl_ext_purify.h
  preprocessing/passes/non_clausal_simp.cpp
  preprocessing/passes/non_clausal_simp.h
  preprocessing/passes/pseudo_boolean_processor.cpp
  preprocessing/passes/pseudo_boolean_processor.h
  preprocessing/passes/quantifier_macros.cpp
  preprocessing/passes/quantifier_macros.h
  preprocessing/passes/quantifiers_preprocess.cpp
  preprocessing/passes/quantifiers_preprocess.h
  preprocessing/passes/real_to_int.cpp
  preprocessing/passes/real_to_int.h
  preprocessing/passes/rewrite.cpp
  preprocessing/passes/rewrite.h
  preprocessing/passes/sep_skolem_emp.cpp
  preprocessing/passes/sep_skolem_emp.h
  preprocessing/passes/sort_infer.cpp
  preprocessing/passes/sort_infer.h
  preprocessing/passes/static_learning.cpp
  preprocessing/passes/static_learning.h
  preprocessing/passes/sygus_inference.cpp
  preprocessing/passes/sygus_inference.h
  preprocessing/passes/synth_rew_rules.cpp
  preprocessing/passes/synth_rew_rules.h
  preprocessing/passes/theory_preprocess.cpp
  preprocessing/passes/theory_preprocess.h
  preprocessing/passes/unconstrained_simplifier.cpp
  preprocessing/passes/unconstrained_simplifier.h
  preprocessing/preprocessing_pass.cpp
  preprocessing/preprocessing_pass.h
  preprocessing/preprocessing_pass_context.cpp
  preprocessing/preprocessing_pass_context.h
  preprocessing/preprocessing_pass_registry.cpp
  preprocessing/preprocessing_pass_registry.h
  preprocessing/util/ite_utilities.cpp
  preprocessing/util/ite_utilities.h
  printer/ast/ast_printer.cpp
  printer/ast/ast_printer.h
  printer/cvc/cvc_printer.cpp
  printer/cvc/cvc_printer.h
  printer/dagification_visitor.cpp
  printer/dagification_visitor.h
  printer/printer.cpp
  printer/printer.h
  printer/smt2/smt2_printer.cpp
  printer/smt2/smt2_printer.h
  printer/sygus_print_callback.cpp
  printer/sygus_print_callback.h
  printer/tptp/tptp_printer.cpp
  printer/tptp/tptp_printer.h
  proof/arith_proof.cpp
  proof/arith_proof.h
  proof/arith_proof_recorder.cpp
  proof/arith_proof_recorder.h
  proof/array_proof.cpp
  proof/array_proof.h
  proof/bitvector_proof.cpp
  proof/bitvector_proof.h
  proof/clausal_bitvector_proof.cpp
  proof/clausal_bitvector_proof.h
  proof/clause_id.h
  proof/cnf_proof.cpp
  proof/cnf_proof.h
  proof/dimacs.cpp
  proof/dimacs.h
  proof/drat/drat_proof.cpp
  proof/drat/drat_proof.h
  proof/er/er_proof.cpp
  proof/er/er_proof.h
  proof/lemma_proof.cpp
  proof/lemma_proof.h
  proof/lfsc_proof_printer.cpp
  proof/lfsc_proof_printer.h
  proof/lrat/lrat_proof.cpp
  proof/lrat/lrat_proof.h
  proof/proof.h
  proof/proof_manager.cpp
  proof/proof_manager.h
  proof/proof_output_channel.cpp
  proof/proof_output_channel.h
  proof/proof_utils.cpp
  proof/proof_utils.h
  proof/resolution_bitvector_proof.cpp
  proof/resolution_bitvector_proof.h
  proof/sat_proof.h
  proof/sat_proof_implementation.h
  proof/simplify_boolean_node.cpp
  proof/simplify_boolean_node.h
  proof/skolemization_manager.cpp
  proof/skolemization_manager.h
  proof/theory_proof.cpp
  proof/theory_proof.h
  proof/uf_proof.cpp
  proof/uf_proof.h
  proof/unsat_core.cpp
  proof/unsat_core.h
  prop/bvminisat/bvminisat.cpp
  prop/bvminisat/bvminisat.h
  prop/bvminisat/core/Dimacs.h
  prop/bvminisat/core/Solver.cc
  prop/bvminisat/core/Solver.h
  prop/bvminisat/core/SolverTypes.h
  prop/bvminisat/mtl/Alg.h
  prop/bvminisat/mtl/Alloc.h
  prop/bvminisat/mtl/Heap.h
  prop/bvminisat/mtl/IntTypes.h
  prop/bvminisat/mtl/Map.h
  prop/bvminisat/mtl/Queue.h
  prop/bvminisat/mtl/Sort.h
  prop/bvminisat/mtl/Vec.h
  prop/bvminisat/mtl/XAlloc.h
  prop/bvminisat/simp/SimpSolver.cc
  prop/bvminisat/simp/SimpSolver.h
  prop/bvminisat/utils/Options.h
  prop/cadical.cpp
  prop/cadical.h
  prop/cnf_stream.cpp
  prop/cnf_stream.h
  prop/cryptominisat.cpp
  prop/cryptominisat.h
  prop/kissat.cpp
  prop/kissat.h
  prop/minisat/core/Dimacs.h
  prop/minisat/core/Solver.cc
  prop/minisat/core/Solver.h
  prop/minisat/core/SolverTypes.h
  prop/minisat/minisat.cpp
  prop/minisat/minisat.h
  prop/minisat/mtl/Alg.h
  prop/minisat/mtl/Alloc.h
  prop/minisat/mtl/Heap.h
  prop/minisat/mtl/IntTypes.h
  prop/minisat/mtl/Map.h
  prop/minisat/mtl/Queue.h
  prop/minisat/mtl/Sort.h
  prop/minisat/mtl/Vec.h
  prop/minisat/mtl/XAlloc.h
  prop/minisat/simp/SimpSolver.cc
  prop/minisat/simp/SimpSolver.h
  prop/minisat/utils/Options.h
  prop/prop_engine.cpp
  prop/prop_engine.h
  prop/registrar.h
  prop/sat_solver.h
  prop/sat_solver_factory.cpp
  prop/sat_solver_factory.h
  prop/bv_sat_solver_notify.h
  prop/sat_solver_types.cpp
  prop/sat_solver_types.h
  prop/theory_proxy.cpp
  prop/theory_proxy.h
  smt/command.cpp
  smt/command.h
  smt/command_list.cpp
  smt/command_list.h
  smt/defined_function.h
  smt/dump.cpp
  smt/dump.h
  smt/logic_exception.h
  smt/logic_request.cpp
  smt/logic_request.h
  smt/managed_ostreams.cpp
  smt/managed_ostreams.h
  smt/model.cpp
  smt/model.h
  smt/model_core_builder.cpp
  smt/model_core_builder.h
  smt/model_blocker.cpp
  smt/model_blocker.h
  smt/process_assertions.cpp
  smt/process_assertions.h
  smt/set_defaults.cpp
  smt/set_defaults.h
  smt/smt_engine.cpp
  smt/smt_engine.h
  smt/smt_engine_scope.cpp
  smt/smt_engine_scope.h
  smt/smt_engine_stats.cpp
  smt/smt_engine_stats.h
  smt/smt_statistics_registry.cpp
  smt/smt_statistics_registry.h
  smt/term_formula_removal.cpp
  smt/term_formula_removal.h
  smt/update_ostream.h
  smt_util/boolean_simplification.cpp
  smt_util/boolean_simplification.h
  smt_util/nary_builder.cpp
  smt_util/nary_builder.h
  theory/arith/approx_simplex.cpp
  theory/arith/approx_simplex.h
  theory/arith/arith_ite_utils.cpp
  theory/arith/arith_ite_utils.h
  theory/arith/arith_msum.cpp
  theory/arith/arith_msum.h
  theory/arith/arith_rewriter.cpp
  theory/arith/arith_rewriter.h
  theory/arith/arith_static_learner.cpp
  theory/arith/arith_static_learner.h
  theory/arith/arith_utilities.cpp
  theory/arith/arith_utilities.h
  theory/arith/arithvar.cpp
  theory/arith/arithvar.h
  theory/arith/attempt_solution_simplex.cpp
  theory/arith/attempt_solution_simplex.h
  theory/arith/bound_counts.h
  theory/arith/callbacks.cpp
  theory/arith/callbacks.h
  theory/arith/congruence_manager.cpp
  theory/arith/congruence_manager.h
  theory/arith/constraint.cpp
  theory/arith/constraint.h
  theory/arith/constraint_forward.h
  theory/arith/cut_log.cpp
  theory/arith/cut_log.h
  theory/arith/delta_rational.cpp
  theory/arith/delta_rational.h
  theory/arith/dio_solver.cpp
  theory/arith/dio_solver.h
  theory/arith/dual_simplex.cpp
  theory/arith/dual_simplex.h
  theory/arith/error_set.cpp
  theory/arith/error_set.h
  theory/arith/fc_simplex.cpp
  theory/arith/fc_simplex.h
  theory/arith/infer_bounds.cpp
  theory/arith/infer_bounds.h
  theory/arith/linear_equality.cpp
  theory/arith/linear_equality.h
  theory/arith/matrix.cpp
  theory/arith/matrix.h
  theory/arith/nl/nl_constraint.cpp
  theory/arith/nl/nl_constraint.h
  theory/arith/nl/nl_lemma_utils.cpp
  theory/arith/nl/nl_lemma_utils.h
  theory/arith/nl/nl_model.cpp
  theory/arith/nl/nl_model.h
  theory/arith/nl/nl_monomial.cpp
  theory/arith/nl/nl_monomial.h
  theory/arith/nl/nl_solver.cpp
  theory/arith/nl/nl_solver.h
  theory/arith/nl/nonlinear_extension.cpp
  theory/arith/nl/nonlinear_extension.h
  theory/arith/nl/transcendental_solver.cpp
  theory/arith/nl/transcendental_solver.h
  theory/arith/normal_form.cpp
  theory/arith/normal_form.h
  theory/arith/partial_model.cpp
  theory/arith/partial_model.h
  theory/arith/simplex.cpp
  theory/arith/simplex.h
  theory/arith/simplex_update.cpp
  theory/arith/simplex_update.h
  theory/arith/soi_simplex.cpp
  theory/arith/soi_simplex.h
  theory/arith/tableau.cpp
  theory/arith/tableau.h
  theory/arith/tableau_sizes.cpp
  theory/arith/tableau_sizes.h
  theory/arith/theory_arith.cpp
  theory/arith/theory_arith.h
  theory/arith/theory_arith_private.cpp
  theory/arith/theory_arith_private.h
  theory/arith/theory_arith_private_forward.h
  theory/arith/theory_arith_type_rules.h
  theory/arith/type_enumerator.h
  theory/arrays/array_info.cpp
  theory/arrays/array_info.h
  theory/arrays/array_proof_reconstruction.cpp
  theory/arrays/array_proof_reconstruction.h
  theory/arrays/static_fact_manager.cpp
  theory/arrays/static_fact_manager.h
  theory/arrays/theory_arrays.cpp
  theory/arrays/theory_arrays.h
  theory/arrays/theory_arrays_rewriter.cpp
  theory/arrays/theory_arrays_rewriter.h
  theory/arrays/theory_arrays_type_rules.h
  theory/arrays/type_enumerator.h
  theory/arrays/union_find.cpp
  theory/arrays/union_find.h
  theory/assertion.cpp
  theory/assertion.h
  theory/atom_requests.cpp
  theory/atom_requests.h
  theory/booleans/circuit_propagator.cpp
  theory/booleans/circuit_propagator.h
  theory/booleans/proof_checker.cpp
  theory/booleans/proof_checker.h
  theory/booleans/theory_bool.cpp
  theory/booleans/theory_bool.h
  theory/booleans/theory_bool_rewriter.cpp
  theory/booleans/theory_bool_rewriter.h
  theory/booleans/theory_bool_type_rules.h
  theory/booleans/type_enumerator.h
  theory/builtin/theory_builtin.cpp
  theory/builtin/theory_builtin.h
  theory/builtin/theory_builtin_rewriter.cpp
  theory/builtin/theory_builtin_rewriter.h
  theory/builtin/theory_builtin_type_rules.h
  theory/builtin/proof_checker.cpp
  theory/builtin/proof_checker.h
  theory/builtin/type_enumerator.cpp
  theory/builtin/type_enumerator.h
  theory/bv/abstraction.cpp
  theory/bv/abstraction.h
  theory/bv/bitblast/aig_bitblaster.cpp
  theory/bv/bitblast/aig_bitblaster.h
  theory/bv/bitblast/bitblast_strategies_template.h
  theory/bv/bitblast/bitblast_utils.h
  theory/bv/bitblast/bitblaster.h
  theory/bv/bitblast/eager_bitblaster.cpp
  theory/bv/bitblast/eager_bitblaster.h
