=== debian/changelog ===
cvc4 (1.8-5) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * Fix FTBFS with CMake 4. Closes: #1112823.

  [ Santiago Vila ]
  * Drop "Priority: optional" (default).
  * Update standards-version.
  * Add debian/salsa.yml.

 -- Santiago Vila <sanvila@debian.org>  Mon, 27 Oct 2025 10:10:00 +0100

cvc4 (1.8-4) unstable; urgency=medium

  * Team upload.
  * Patch-out usage of python3-toml
  * Fix Team email address

 -- Alexandre Detiste <tchet@debian.org>  Sun, 27 Jul 2025 16:05:53 +0200

cvc4 (1.8-3) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with bash 5.2 (Closes: #1020010)
  * Fix FTBFS due to cryptominisat API changes by disabling cryptominisat

 -- Scott Talbert <swt@techie.net>  Sat, 29 Oct 2022 14:49:40 -0400

cvc4 (1.8-2) unstable; urgency=medium

  * Source-only reupload after the package has been through NEW.
  * Add patch 06-disable-tests.patch to disable several failing test
    cases that prevent the package from building on all release
    architectures it has previously been built on (see #970511).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Thu, 17 Sep 2020 18:29:09 +0200

cvc4 (1.8-1) unstable; urgency=medium

  * New upstream release.
  * Update watch file.
  * Upgrade to debhelper compat level 13.
  * Upgrade to Standards-Version 4.5.0.
  * Update Homepage field in debian/control.
  * Update debian/copyright.
  * Update patches:
     - Rename 01-timestamps.patch into 00-timestamps.patch.
     - Drop 02-man-pages.patch (no longer needed; all man pages get
       installed now).
     - Drop 03-examples.patch (fixed upstream).
     - Drop 04-fix-spelling.patch (fixed upstream).
     - Add 01-disable-tests.patch to disable some lengthy test cases
       that would otherwise be run during the package build.
     - Add 02-install-lib-dir.patch to fix the directory into which
       the shared libraries are installed.
     - Add 03-remove-build-path.patch to help make the build more
       reproducible.
     - Add 04-spelling-errors.patch to fix the spelling errors found
       by Lintian.
     - Add 05-fix-headers.patch to make sure the installed header
       files are actually usable.
  * Switch to CMake build system.
  * Change build architectures to "any" (Closes: #941431).
  * Add print-version and simple-arith autopkgtests.
  * Adjust package names to new SONAME.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sun, 13 Sep 2020 14:04:56 +0200
