=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath

export DEB_CPPFLAGS_MAINT_APPEND = \
	-DDEB_BUILD_DATE="\"$(shell date -d @$(SOURCE_DATE_EPOCH) +%F)\"" \
	-DDEB_BUILD_TIME="\"$(shell date -d @$(SOURCE_DATE_EPOCH) +%T)\""

export DEB_BUILD_BASEDIR = $(shell pwd)
export CCACHE_BASEDIR = $(DEB_BUILD_BASEDIR)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --                                        \
		-DENABLE_GPL=ON -DENABLE_SHARED=ON                  \
		-DENABLE_DEBUG_SYMBOLS=ON -DENABLE_PROOFS=ON        \
		-DENABLE_STATISTICS=ON -DENABLE_DUMPING=ON          \
		-DENABLE_UNIT_TESTING=ON -DENABLE_BEST=ON           \
		-DUSE_READLINE=ON -DUSE_PYTHON3=ON                  \
		-DUSE_ABC=OFF -DUSE_CADICAL=OFF -DUSE_CLN=ON        \
		-DUSE_CRYPTOMINISAT=OFF -DUSE_KISSAT=OFF            \
		-DUSE_GLPK=OFF                                      \
		-DCMAKE_BUILD_TYPE=Production

override_dh_installdocs:
	dh_installdocs --all NEWS AUTHORS THANKS
