=== debian/tests/control ===
Tests: hello-world print-version
Depends: @, build-essential
Restrictions: superficial

Tests: simple-arith
Depends: @
