=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/(\d[\d\.]*)\.tar\.gz/cvc4-$1\.tar\.gz/ \
  https://github.com/CVC4/CVC4/tags .*/(\d[\d\.]*)\.tar\.gz
